Subject: Re: [PATCH net-next v2] netdevsim: call napi_schedule from a timer context

From: Jakub Kicinski <[email-masked]>
Date: Mon, 17 Feb 2025 11:50:31 -0800

On Mon, 17 Feb 2025 09:35:29 -0800 Breno Leitao wrote:
> The netdevsim driver was experiencing NOHZ tick-stop errors during packet
> transmission due to pending softirq work when calling napi_schedule().
> This issue was observed when running the netconsole selftest, which
> triggered the following error message:
> 
>   NOHZ tick-stop error: local softirq work is pending, handler #08!!!
> 
> To fix this issue, introduce a timer that schedules napi_schedule()
> from a timer context instead of calling it directly from the TX path.
> 
> Create an hrtimer for each queue and kick it from the TX path,
> which then schedules napi_schedule() from the timer context.

This crashes in the nl_netdev test.

I think you should move the hrtimer init to nsim_queue_alloc()
and removal to nsim_queue_free()
-- 
pw-bot: cr